document.addEventListener("DOMContentLoaded", () => {
  const sections = document.querySelectorAll("section");
  const navLinks = document.querySelectorAll("#navbar li a");

  const observerOptions = {
    root: null, // Use the viewport as the root
    threshold: 0.5, // Trigger when 50% of the section is visible
  };

  const observer = new IntersectionObserver((entries) => {
    entries.forEach((entry) => {
      const sectionId = entry.target.getAttribute("id");
      const navLink = document.querySelector(
        `#navbar li a[href="#${sectionId}"]`
      );

      if (entry.isIntersecting) {
        // Remove active class from all links
        navLinks.forEach((link) => link.classList.remove("active"));
        // Add active class to the current link
        navLink.classList.add("active");
      }
    });
  }, observerOptions);

  // Observe each section
  sections.forEach((section) => observer.observe(section));

  let backtotop = document.querySelector(".back-to-top");
  if (backtotop) {
    const toggleBacktotop = () => {
      if (window.scrollY > 90) {
        backtotop.classList.add("activeArrow");
      } else {
        backtotop.classList.remove("activeArrow");
      }
    };
    window.addEventListener("scroll", toggleBacktotop);
  }

  changeCourse();
});
function closeOffcanvas() {
  const offcanvasElement = document.getElementById("offcanvasRight");
  const offcanvas =
    bootstrap.Offcanvas.getInstance(offcanvasElement) ||
    new bootstrap.Offcanvas(offcanvasElement);
  offcanvas.hide();
}

function changeCourse() {
  const bpedDiv = document.getElementById("bped");
  const btledDiv = document.getElementById("btled");
  const selectedCourse = document.getElementById("selectCourse");
  const selectFirst = document.getElementById("selectFirst");

  // Set initial display for both divs
  bpedDiv.style.display = "none";
  btledDiv.style.display = "none";

  // Event listener for selection change
  selectedCourse.addEventListener("change", () => {
    if (selectedCourse.value !== "") {
      selectFirst.style.display = "none";
    }
    if (selectedCourse.value === "bped") {
      bpedDiv.style.display = "flex";
      btledDiv.style.display = "none";
    } else if (selectedCourse.value === "btled") {
      btledDiv.style.display = "flex";
      bpedDiv.style.display = "none";
    } else {
      // Hide both if no valid course is selected
      bpedDiv.style.display = "none";
      btledDiv.style.display = "none";
      selectFirst.style.display = "block";
    }
  });
}
