//S W E E T  A L E R T
async function AsyncSwalLoading(callback) {
  // Show loading modal
  const loadingSwal = Swal.fire({
    title: "Loading",
    text: "Please wait...",
    allowEscapeKey: false,
    allowOutsideClick: false,
    didOpen: () => {
      Swal.showLoading()
      // Execute your function here
      callback()
    },
  })

  // Wait for the loading modal to be closed
  await loadingSwal

  // Show finished message
  Swal.fire({
    title: "Finished!",
    icon: "success",
    timer: 1500,
    showConfirmButton: false,
  }).catch(Swal.noop)
}

function SwalLoading(callback) {
  // Show loading modal
  const loadingSwal = Swal.fire({
    title: "Loading",
    text: "Please wait...",
    allowEscapeKey: false,
    allowOutsideClick: false,
    didOpen: () => {
      Swal.showLoading()
      // Execute your function here
      callback()
    },
  })

  // Wait for the loading modal to be closed
  loadingSwal.then(() => {
    // Show finished message
    Swal.fire({
      title: "Finished!",
      icon: "success",
      timer: 1500,
      showConfirmButton: false,
    }).catch(Swal.noop)
  })
}

function swalMessage(
  title = "",
  message,
  icon,
  _callback = "",
  confirm_text = "Ok"
) {
  Swal.fire({
    title: title,
    html: message,
    allowEscapeKey: false,
    allowOutsideClick: false,
    confirmButtonText: confirm_text,
    icon: icon,
  }).then(function () {
    if (_callback != "") _callback()
  })
}

function swalLoad(title = "") {
  swal.fire({
    title: title,
    html:
      '<div class="spinner-border text-primary m-4" role="status">' +
      '<span class="visually-hidden">Loading...</span>' +
      "</div>",
    allowEscapeKey: false,
    allowOutsideClick: false,
    showConfirmButton: false,
    // timer: 500,
  })
}

function loadPage(x = false, replace = false) {
  swalLoad("Loading")
  if (!x) {
    location.reload()
  } else {
    if (replace) {
      location.replace(x)
    } else {
      location.href = x
    }
  }
}

function swalDecide(
  message,
  title = "",
  icon,
  _callback = "",
  confirm_text = "Proceed",
  cancel_text = "Cancel"
) {
  Swal.fire({
    title: title,
    html: message,
    allowEscapeKey: false,
    allowOutsideClick: false,
    showCancelButton: true,
    confirmButtonText: confirm_text,
    cancelButtonText: cancel_text,
    icon: icon,
  }).then(function (isconfirm) {
    if (isconfirm.value) {
      var _reply = true
      swalLoad("Loading")
    } else {
      var _reply = false
    }
    if (_callback != "") _callback(_reply)
  })
}

function swalDecideClose(
  message,
  title = "",
  icon,
  _callback = "",
  confirm_text = "Proceed",
  cancel_text = "Cancel"
) {
  Swal.fire({
    title: title,
    html: message,
    allowEscapeKey: false,
    allowOutsideClick: false,
    showCancelButton: true,
    showCloseButton: true,
    confirmButtonText: confirm_text,
    cancelButtonText: cancel_text,
    icon: icon,
  }).then(function (isconfirm) {
    if (isconfirm.value) {
      var _reply = true
      swalLoad("Loading")
    } else {
      var _reply = false
    }
    if (_callback != "") _callback(_reply)
  })
}

function swalDecidePerson(title, text, icon, callback) {
  swal({
    title: title,
    text: text,
    icon: icon,
    buttons: {
      cancel: {
        text: "Cancel",
        value: null,
        visible: true,
        className: "",
        closeModal: true,
      },
      confirm: {
        text: "OK",
        value: true,
        visible: true,
        className: "",
        closeModal: true,
      },
    },
  }).then(callback)
}

//CONTEXTMENU

function initializeContextMenuDT(
  _selector,
  _trigger,
  _hideOnSecondTrigger,
  _callback,
  _items,
  _callback_behavior
) {
  $(document).on("click", _selector + "", function () {
    _callback_behavior(this)
  })

  $.contextMenu({
    selector: _selector,
    trigger: _trigger,
    hideOnSecondTrigger: _hideOnSecondTrigger,
    callback: function (key, options) {
      _callback(key, options)
    },
    events: {
      preShow: function () {
        if ($(_selector).has("td.dataTables_empty").length > 0) {
          $(_selector).contextMenu(false)
        } else {
          $(_selector).contextMenu(true)
        }
      },
      hide: function (options) {
        $(_selector).removeClass("selected_row")
        return true
      },
    },
    items: _items,
  })
}

//DATA TABLE

function initiateDTable(id, column_sort = 0, sort_type = "asc") {
  var table = $(id).DataTable()
  $(id).dataTable().fnDestroy()

  var table = $(id).DataTable({
    searching: false,
    paging: false,
    columnDefs: [
      {
        targets: "_all",
        // render: $.fn.dataTable.render.ellipsis(),
      },
    ],
    info: false,
    order: [[column_sort, sort_type]],
  })

  return table
}

function DisplayDataTable(
  data,
  id,
  column,
  _searching = true,
  _ordering = true,
  _responsive = true,
  // _scrollX = true,
  // _scrollY = true,
  _scrollCollapse = true,
  _paging = true
  // _bDest = true
) {
  $(document).ready(function () {
    var arr = []
    for (var i = 0; i < column.length; i++) {
      arr.push({ data: column[i] })
    }

    const table = new $("#" + id).DataTable({
      destroy: true,
      ordering: _ordering,
      data: data,
      searching: _searching,
      responsive: _responsive,
      // scrollX: _scrollX,
      // scrollY: _scrollY,
      scrollCollapse: _scrollCollapse,
      paging: _paging,
      columns: arr,
      // bDesctrot: _bDest,
      //"bAutoWidth": false,
      info: false,
    })

    $(window).resize(function () {
      table.columns.adjust()
    })
  })
}

function disableForm(id) {
  $("#" + id)
    .find("input, select, textarea")
    .prop("disabled", true)
}
function enableForm(id) {
  $("#" + id)
    .find("input, select, textarea")
    .prop("disabled", false)
}

//CMS
// function UseContextMenu(selector, item, _process)
// {
//     $.contextMenu({
//         selector: selector,
//         callback: function(key, options) {
//             //var m = "clicked: " + key;
//             //window.console && console.log(m) || alert(m);
//             _process(key);
//             },
//             items: item
//             //{
//             //     "edit": {name: "Edit"},
//             //     "sep1": "---------",
//             //     "cut": {name: "Cut"},
//             //    "copy": {name: "Copy"},
//             //     "paste": {name: "Paste"},
//             //     "delete": {name: "Delete"},
//             //     "sep2": "---------",
//             //     "quit": {name: "Quit"}
//             // }
//         });
// }

//SELECT 2

// function initializeSelect2(_id, _url, _valid = false, _withParent = "") {
//   $("#" + _id)
//     .select2({
//       minimumInputLength: 3,
//       allowClear: true,
//       placeholder: "--Select--",
//       ajax: {
//         type: "POST",
//         url: "../../../controllers/select2_filters/" + _url,
//         delay: 400,
//         dataType: "json",
//         data: function (params) {
//           return {
//             token: $("#token").val(),
//             toFilter: params.term,
//             select2: true,
//           }
//         },
//         processResults: function (data, params) {
//           if (data.mess == "connection") {
//             swalMessage(
//               "The Server is temporarily unable to serve your request due to maintenance, downtime or capacity problem. Please try again later.",
//               "Service Unavailable",
//               "warning",
//               function () {
//                 swal.close()
//               }
//             )
//           } else if (data.mess == "token") {
//             swalMessage("", "Invalid Token", "warning", function () {
//               swal.close()
//               // loadPage();
//             })
//           } else if (data.mess == "timeout") {
//             swalMessage(
//               "Your account will be logged out as there was no request in 30 minutes.",
//               "Session Timeout ",
//               "warning",
//               function () {
//                 swal.close()
//                 loadPage(
//                   "../../controllers/shared/logout_ctrlr.php?timeout=true",
//                   true
//                 )
//               }
//             )
//           } else {
//             var select2Data = $.map(data, function (obj) {
//               return obj
//             })

//             return {
//               results: select2Data,
//             }
//           }
//         },
//       },
//     })
//     .next()
//     .after(
//       '<label id="' +
//         _id +
//         '-error" class="error" for = "' +
//         _id +
//         '" style = "display: none"></label>'
//     )

//   $(".select2").css("width", "100%")

//   if (_valid) {
//     $("#" + _id).on("select2:select", function (e) {
//       $("#" + _id).valid()
//     })
//   }
// }

function initializeSelect2(_id, _url, _valid = false) {
  $("#" + _id)
    .select2({
      minimumInputLength: 3,
      allowClear: true,
      placeholder: "-Select-",
      templateResult: function (result) {
        var _text = result.text.split("|")
        if (_text.length > 1) {
          return $(
            "<span><b>" +
              _text[0] +
              "</b></br><span style='font-size:10px'>" +
              _text[1] +
              "</span></br><span style='font-size:10px'>" +
              _text[2] +
              "</span></span>"
          )
        } else {
          return $("<span>" + result.text + "</span>")
        }
      },
      templateSelection: function (result) {
        var _text = result.text.split("|")
        if (_text.length > 1) {
          return $("<span>" + _text[0] + " - " + _text[1] + "</span>")
        } else {
          return $("<span>" + result.text + "</span>")
        }
      },
      ajax: {
        type: "POST",
        url: "../../controllers/filter/" + _url,
        delay: 400,
        dataType: "json",
        data: function (params) {
          return {
            token: $("#token").val(),
            toFilter: params.term,
            select2: true,
          }
        },
        processResults: function (data, params) {
          if (data.mess == "connection") {
            swalMessage(
              "The Server is temporarily unable to serve your request due to maintenance, downtime or capacity problem. Please try again later.",
              "Service Unavailable",
              "warning",
              function () {
                swal.close()
              }
            )
          } else if (data.mess == "token") {
            swalMessage("", "Invalid Token", "warning", function () {
              swal.close()
              // loadPage();
            })
          } else if (data.mess == "timeout") {
            swalMessage(
              "Your account will be logged out as there was no request in 30 minutes.",
              "Session Timeout ",
              "warning",
              function () {
                swal.close()
                loadPage(
                  "../../controllers/shared/logout_ctrlr.php?timeout=true",
                  true
                )
              }
            )
          } else {
            var select2Data = $.map(data, function (obj) {
              return obj
            })

            return {
              results: select2Data,
            }
          }
        },
      },
    })
    .next()
    .after(
      '<label id="' +
        _id +
        '-error" class="error" for = "' +
        _id +
        '" style = "display: none"></label>'
    )

  $(".select2").css("width", "100%")

  if (_valid) {
    $("#" + _id).on("select2:select", function (e) {
      $("#" + _id).valid()
    })
  }
}

function initializeSelect2Modal(
  modal_name,
  _id,
  _url,
  _valid = false,
  _withParent = ""
) {
  $("#" + _id)
    .select2({
      dropdownParent: $("#" + modal_name),
      minimumInputLength: 3,
      allowClear: true,
      placeholder: "--Select--",
      ajax: {
        type: "POST",
        url: "../../../controllers/select2_filters/" + _url,
        delay: 400,
        dataType: "json",
        data: function (params) {
          return {
            token: $("#token").val(),
            toFilter: params.term,
            select2: true,
          }
        },
        processResults: function (data, params) {
          if (data.mess == "connection") {
            swalMessage(
              "The Server is temporarily unable to serve your request due to maintenance, downtime or capacity problem. Please try again later.",
              "Service Unavailable",
              "warning",
              function () {
                swal.close()
              }
            )
          } else if (data.mess == "token") {
            swalMessage("", "Invalid Token", "warning", function () {
              swal.close()
              // loadPage();
            })
          } else if (data.mess == "timeout") {
            swalMessage(
              "Your account will be logged out as there was no request in 30 minutes.",
              "Session Timeout ",
              "warning",
              function () {
                swal.close()
                loadPage(
                  "../../controllers/shared/logout_ctrlr.php?timeout=true",
                  true
                )
              }
            )
          } else {
            var select2Data = $.map(data, function (obj) {
              return obj
            })

            return {
              results: select2Data,
            }
          }
        },
      },
    })
    .next()
    .after(
      '<label id="' +
        _id +
        '-error" class="error" for = "' +
        _id +
        '" style = "display: none"></label>'
    )

  $(".select2").css("width", "100%")

  if (_valid) {
    $("#" + _id).on("select2:select", function (e) {
      $("#" + _id).valid()
    })
  }
}

function initializeSelect2Link(_id, _url, _valid = false, _agendaID) {
  $("#" + _id)
    .select2({
      minimumInputLength: 3,
      allowClear: true,
      placeholder: "--Select--",
      ajax: {
        type: "POST",
        url: "../../../controllers/select2_filters/" + _url,
        delay: 400,
        dataType: "json",
        data: function (params) {
          return {
            token: $("#token").val(),
            toFilter: params.term,
            select2: true,
            agenda_id: _agendaID,
          }
        },
        processResults: function (data, params) {
          if (data.mess == "connection") {
            swalMessage(
              "The Server is temporarily unable to serve your request due to maintenance, downtime or capacity problem. Please try again later.",
              "Service Unavailable",
              "warning",
              function () {
                swal.close()
              }
            )
          } else if (data.mess == "token") {
            swalMessage("", "Invalid Token", "warning", function () {
              swal.close()
              // loadPage();
            })
          } else if (data.mess == "timeout") {
            swalMessage(
              "Your account will be logged out as there was no request in 30 minutes.",
              "Session Timeout ",
              "warning",
              function () {
                swal.close()
                loadPage(
                  "../../controllers/shared/logout_ctrlr.php?timeout=true",
                  true
                )
              }
            )
          } else {
            var select2Data = $.map(data, function (obj) {
              return obj
            })

            return {
              results: select2Data,
            }
          }
        },
      },
    })
    .next()
    .after(
      '<label id="' +
        _id +
        '-error" class="error" for = "' +
        _id +
        '" style = "display: none"></label>'
    )

  $(".select2").css("width", "100%")

  if (_valid) {
    $("#" + _id).on("select2:select", function (e) {
      $("#" + _id).valid()
    })
  }
}

// function initializeSelect2try(_id, _url, _cores, _valid = false, _agendaID) {
//   $("#" + _id)
//     .select2({
//       minimumInputLength: 3,
//       allowClear: true,
//       placeholder: "--Select--",
//       ajax: {
//         type: "POST",
//         url: "../../../controllers/select2_filters/" + _url,
//         delay: 400,
//         dataType: "json",
//         data: function (params) {
//           return {
//             token: $("#token").val(),
//             toFilter: params.term,
//             select2: true,
//             agendaID: _agendaID,
//           }
//         },
//         processResults: function (data, params) {
//           if (data.mess == "connection") {
//             swalMessage(
//               "The Server is temporarily unable to serve your request due to maintenance, downtime or capacity problem. Please try again later.",
//               "Service Unavailable",
//               "warning",
//               function () {
//                 swal.close()
//               }
//             )
//           } else if (data.mess == "token") {
//             swalMessage("", "Invalid Token", "warning", function () {
//               swal.close()
//               // loadPage();
//             })
//           } else if (data.mess == "timeout") {
//             swalMessage(
//               "Your account will be logged out as there was no request in 30 minutes.",
//               "Session Timeout ",
//               "warning",
//               function () {
//                 swal.close()
//                 loadPage(
//                   "../../controllers/shared/logout_ctrlr.php?timeout=true",
//                   true
//                 )
//               }
//             )
//           } else {
//             var select2Data = $.map(data, function (obj) {
//               return obj
//             })

//             return {
//               results: select2Data,
//             }
//           }
//         },
//       },
//     })
//     .next()
//     .after(
//       '<label id="' +
//         _id +
//         '-error" class="error" for = "' +
//         _id +
//         '" style = "display: none"></label>'
//     )

//   $(".select2").css("width", "100%")

//   if (_valid) {
//     $("#" + _id).on("select2:select", function (e) {
//       $("#" + _id).valid()
//     })
//   }
// }

function initializeSelect2Business(_id, _url, _agenda_id, _valid = false) {
  $("#" + _id)
    .select2({
      minimumInputLength: 3,
      allowClear: true,
      placeholder: "--Select--",
      ajax: {
        type: "POST",
        url: "../../../controllers/select2_filters/" + _url,
        delay: 400,
        dataType: "json",
        data: function (params) {
          return {
            token: $("#token").val(),
            toFilter: params.term,
            agenda_id: _agenda_id,
            select2: true,
          }
        },
        processResults: function (data, params) {
          if (data.mess == "connection") {
            swalMessage(
              "The Server is temporarily unable to serve your request due to maintenance, downtime or capacity problem. Please try again later.",
              "Service Unavailable",
              "warning",
              function () {
                swal.close()
              }
            )
          } else if (data.mess == "token") {
            swalMessage("", "Invalid Token", "warning", function () {
              swal.close()
              // loadPage();
            })
          } else if (data.mess == "timeout") {
            swalMessage(
              "Your account will be logged out as there was no request in 30 minutes.",
              "Session Timeout ",
              "warning",
              function () {
                swal.close()
                loadPage(
                  "../../controllers/shared/logout_ctrlr.php?timeout=true",
                  true
                )
              }
            )
          } else {
            var select2Data = $.map(data, function (obj) {
              return obj
            })

            return {
              results: select2Data,
            }
          }
        },
      },
    })
    .next()
    .after(
      '<label id="' +
        _id +
        '-error" class="error" for = "' +
        _id +
        '" style = "display: none"></label>'
    )

  $(".select2").css("width", "100%")

  if (_valid) {
    $("#" + _id).on("select2:select", function (e) {
      $("#" + _id).valid()
    })
  }
}

function initializeDatePicker(id, option = "") {
  if (option == "") {
    option = { format: "yyyy-mm-dd", startView: 2 }
  } else {
    if (option.format) {
    } else {
      option.format = "yyyy-mm-dd"
      option.startView = 2
    }
  }

  option.autoclose = true
  option.clearBtn = false

  $(document).on("focus", id, function () {
    $(id).datepicker(option)
  })

  $(id).prop("readonly", true)
  $(id).css("background-color", "white")
  $(id).css("cursor", "pointer")
}

function validateForm(selector, _rules = {}, _submitHandler) {
  $(selector).validate({
    ignore: [],
    normalizer: function (value) {
      return $.trim(value)
    },
    rules: _rules,
    submitHandler: function (form, e) {
      e.preventDefault()

      swalLoad("Please Wait")
      _submitHandler()
    },
  })
}

// B E H A V I O R
// A J A X
function ajaxPost(_url, _objectData, _callback) {
  try {
    _objectData.token = $("#token").val()
    var promise = $.ajax({
      type: "POST",
      data: _objectData,
      url: "../../controllers/" + _url,
      beforeSubmit: function () {
        swalLoad("Loading")
      },
      success: function (response) {
        swal.close()
        // console.log(response)
        try {
          if (_debug) {
            // console.log(response)
          }
          var response = JSON.parse(response)
          _callback(response)
        } catch (e) {
          swalMessage("System Error", "Script not executed properly", "error")
        }
      },
      error: function (jqXHR, exception) {
        var _msg = "Please try again later"
        if (jqXHR.status === 0) {
          var title = "No Internet Connection"
          _msg = ""
        } else if (jqXHR.status == 404) {
          var title = "Requested Page Not Found"
        } else if (jqXHR.status == 500) {
          var title = "Internal Server Error."
        } else if (exception === "parsererror") {
          var title = "Requested JSON parse failed."
        } else if (exception === "timeout") {
          var title = "Time Out Error."
        } else if (exception === "abort") {
          var title = "Ajax Request Aborted."
        } else {
          var title = "System Error"
        }
        swalMessage(title, _msg, "error")
      },
      complete: function () {},
    })
  } catch (e) {
    swalMessage(
      "System Error",
      "Script not executed properly",
      "error",
      function () {}
    )
  }
}

async function ajaxPostAsync(_url, _objectData, _callback) {
  try {
    _objectData.token = $("#token").val()
    var promise = await $.ajax({
      type: "POST",
      data: _objectData,
      url: "../../controllers/" + _url,
      beforeSubmit: function () {
        swalLoad("Loading")
      },
      success: function (response) {
        swal.close()
        console.log(response)
        try {
          if (_debug) {
            console.log(response)
          }
          var response = JSON.parse(response)
          _callback(response)
        } catch (e) {
          swalMessage("System Error", "Script not executed properly", "error")
        }
      },
      error: function (jqXHR, exception) {
        var _msg = "Please try again later"
        if (jqXHR.status === 0) {
          var title = "No Internet Connection"
          _msg = ""
        } else if (jqXHR.status == 404) {
          var title = "Requested Page Not Found"
        } else if (jqXHR.status == 500) {
          var title = "Internal Server Error."
        } else if (exception === "parsererror") {
          var title = "Requested JSON parse failed."
        } else if (exception === "timeout") {
          var title = "Time Out Error."
        } else if (exception === "abort") {
          var title = "Ajax Request Aborted."
        } else {
          var title = "System Error"
        }
        swalMessage(title, _msg, "error")
      },
      complete: function () {},
    })
  } catch (e) {
    swalMessage(
      "System Error",
      "Script not executed properly",
      "error",
      function () {}
    )
  }
}

function ajaxPostView(_url, _objectData, _callback) {
  try {
    _objectData.token = $("#token").val()
    var promise = $.ajax({
      type: "POST",
      data: _objectData,
      url: "../../../controllers/" + _url,
      beforeSubmit: function () {
        swalLoad("Loading")
      },
      success: function (response) {
        swal.close()

        try {
          if (_debug) {
            console.log(response)
          }
          var response = JSON.parse(response)
          _callback(response)
        } catch (e) {
          swalMessage("System Error", "Script not executed properly", "error")
        }
      },
      error: function (jqXHR, exception) {
        var _msg = "Please try again later"
        if (jqXHR.status === 0) {
          var title = "No Internet Connection"
          _msg = ""
        } else if (jqXHR.status == 404) {
          var title = "Requested Page Not Found"
        } else if (jqXHR.status == 500) {
          var title = "Internal Server Error."
        } else if (exception === "parsererror") {
          var title = "Requested JSON parse failed."
        } else if (exception === "timeout") {
          var title = "Time Out Error."
        } else if (exception === "abort") {
          var title = "Ajax Request Aborted."
        } else {
          var title = "System Error"
        }
        swalMessage(title, _msg, "error")
      },
      complete: function () {},
    })
  } catch (e) {
    swalMessage(
      "System Error",
      "Script not executed properly",
      "error",
      function () {}
    )
  }
}

async function ajaxPostViewAsync(_url, _objectData, _callback) {
  try {
    _objectData.token = $("#token").val()
    var promise = await $.ajax({
      type: "POST",
      data: _objectData,
      url: "../../../controllers/" + _url,
      beforeSubmit: function () {
        swalLoad("Loading")
      },
      success: function (response) {
        swal.close()
        console.log(response)
        try {
          if (_debug) {
            console.log(response)
          }
          var response = JSON.parse(response)
          _callback(response)
        } catch (e) {
          swalMessage("System Error", "Script not executed properly", "error")
        }
      },
      error: function (jqXHR, exception) {
        var _msg = "Please try again later"
        if (jqXHR.status === 0) {
          var title = "No Internet Connection"
          _msg = ""
        } else if (jqXHR.status == 404) {
          var title = "Requested Page Not Found"
        } else if (jqXHR.status == 500) {
          var title = "Internal Server Error."
        } else if (exception === "parsererror") {
          var title = "Requested JSON parse failed."
        } else if (exception === "timeout") {
          var title = "Time Out Error."
        } else if (exception === "abort") {
          var title = "Ajax Request Aborted."
        } else {
          var title = "System Error"
        }
        swalMessage(title, _msg, "error")
      },
      complete: function () {},
    })
  } catch (e) {
    swalMessage(
      "System Error",
      "Script not executed properly",
      "error",
      function () {}
    )
  }
}

function ajaxPostWithUpload(_url, _formData, _callback) {
  try {
    _formData.append("token", $("#token").val())
    $(".bar").width(0)
    $(".percent").html("0.00%")
    var promise = $.ajax({
      xhr: function () {
        var xhr = new window.XMLHttpRequest()
        xhr.upload.addEventListener(
          "progress",
          function (evt) {
            if (evt.lengthComputable) {
              var percentComplete = (evt.loaded / evt.total) * 100
              $(".bar").animate({ width: percentComplete + "%" }, 100)
              $(".percent").html(percentComplete.toFixed(2) + "%")
              if (percentComplete == 100) {
                $(".upload-title").html("Finishing Up...")
              } else {
                $(".upload-title").html("Uploading...")
              }
            }
          },
          false
        )
        return xhr
      },
      data: _formData,
      url: "../../../controllers/" + _url,
      type: "POST",
      contentType: false,
      processData: false,
      beforeSubmit: function () {
        swalLoad("Please Wait")
      },
      success: function (response) {
        swal.close()
        try {
          if (_debug) {
            console.log(response)
          }
          var response = JSON.parse(response)
          _callback(response)
        } catch (e) {
          swalMessage("Script not executed properly", "System Error", "error")
        }
      },
      error: function (jqXHR, exception) {
        var _msg = "Please try again later"
        if (jqXHR.status === 0) {
          var title = "No Internet Connection"
          _msg = ""
        } else if (jqXHR.status == 404) {
          var title = "Requested Page Not Found"
        } else if (jqXHR.status == 500) {
          var title = "Internal Server Error."
        } else if (exception === "parsererror") {
          var title = "Requested JSON parse failed."
        } else if (exception === "timeout") {
          var title = "Time Out Error."
        } else if (exception === "abort") {
          var title = "Ajax Request Aborted."
        } else {
          var title = "System Error"
        }
        swalMessage(_msg, title, "error")
      },
      complete: function () {},
    })
  } catch (e) {
    swalMessage(
      "Script not executed properly",
      "System Error",
      "error",
      function () {}
    )
  }
}

function ajaxPostWithUploadNew(_url, _formData, _callback) {
  try {
    _formData.append("token", "wew")
    $(".bar").width(0)
    $(".percent").html("0.00%")
    var promise = $.ajax({
      xhr: function () {
        var xhr = new window.XMLHttpRequest()
        xhr.upload.addEventListener(
          "progress",
          function (evt) {
            if (evt.lengthComputable) {
              var percentComplete = (evt.loaded / evt.total) * 100
              $(".bar").animate({ width: percentComplete + "%" }, 100)
              $(".percent").html(percentComplete.toFixed(2) + "%")
              if (percentComplete == 100) {
                $(".upload-title").html("Finishing Up...")
              } else {
                $(".upload-title").html("Uploading...")
              }
            }
          },
          false
        )
        return xhr
      },
      data: _formData,
      url: "../../../controllers/" + _url,
      type: "POST",
      contentType: false,
      processData: false,
      beforeSubmit: function () {
        swalLoad("Please Wait")
      },
      success: function (response) {
        swal.close()
        try {
          if (_debug) {
            console.log(response)
          }
          var response = JSON.parse(response)
          _callback(response)
        } catch (e) {
          swalMessage("Script not executed properly", "System Error", "error")
        }
      },
      error: function (jqXHR, exception) {
        var _msg = "Please try again later"
        if (jqXHR.status === 0) {
          var title = "No Internet Connection"
          _msg = ""
        } else if (jqXHR.status == 404) {
          var title = "Requested Page Not Found"
        } else if (jqXHR.status == 500) {
          var title = "Internal Server Error."
        } else if (exception === "parsererror") {
          var title = "Requested JSON parse failed."
        } else if (exception === "timeout") {
          var title = "Time Out Error."
        } else if (exception === "abort") {
          var title = "Ajax Request Aborted."
        } else {
          var title = "System Error"
        }
        swalMessage(_msg, title, "error")
      },
      complete: function () {},
    })
  } catch (e) {
    swalMessage(
      "Script not executed properly",
      "System Error",
      "error",
      function () {}
    )
  }
}

async function ajaxPostWithUploadNewAsync(_url, _formData, _callback) {
  try {
    _formData.append("token", "wew")
    $(".bar").width(0)
    $(".percent").html("0.00%")
    var promise = await $.ajax({
      xhr: function () {
        var xhr = new window.XMLHttpRequest()
        xhr.upload.addEventListener(
          "progress",
          function (evt) {
            if (evt.lengthComputable) {
              var percentComplete = (evt.loaded / evt.total) * 100
              $(".bar").animate({ width: percentComplete + "%" }, 100)
              $(".percent").html(percentComplete.toFixed(2) + "%")
              if (percentComplete == 100) {
                $(".upload-title").html("Finishing Up...")
              } else {
                $(".upload-title").html("Uploading...")
              }
            }
          },
          false
        )
        return xhr
      },
      data: _formData,
      url: "../../../controllers/" + _url,
      type: "POST",
      contentType: false,
      processData: false,
      beforeSubmit: function () {
        swalLoad("Please Wait")
      },
      success: function (response) {
        swal.close()
        try {
          if (_debug) {
            console.log(response)
          }
          var response = JSON.parse(response)
          _callback(response)
        } catch (e) {
          swalMessage("Script not executed properly", "System Error", "error")
        }
      },
      error: function (jqXHR, exception) {
        var _msg = "Please try again later"
        if (jqXHR.status === 0) {
          var title = "No Internet Connection"
          _msg = ""
        } else if (jqXHR.status == 404) {
          var title = "Requested Page Not Found"
        } else if (jqXHR.status == 500) {
          var title = "Internal Server Error."
        } else if (exception === "parsererror") {
          var title = "Requested JSON parse failed."
        } else if (exception === "timeout") {
          var title = "Time Out Error."
        } else if (exception === "abort") {
          var title = "Ajax Request Aborted."
        } else {
          var title = "System Error"
        }
        swalMessage(_msg, title, "error")
      },
      complete: function () {},
    })
  } catch (e) {
    swalMessage(
      "Script not executed properly",
      "System Error",
      "error",
      function () {}
    )
  }
}

function ajaxMessage(message) {
  if (message == "connection") {
    swalMessage(
      "The Server is temporarily unable to serve your request due to maintenance, downtime or capacity problem. Please try again later.",
      "Service Unavailable",
      "warning",
      function () {
        swal.close()
      }
    )
  } else if (message == "token") {
    swalMessage("", "Invalid Token", "warning", function () {
      swal.close()
    })
  } else if (message == "timeout") {
    swalMessage(
      "Your account will be logged out as there was no request in 30 minutes.",
      "Session Timeout ",
      "warning",
      function () {
        swal.close()

        loadPage("../../controllers/shared/logout_ctrlr.php?timeout=true", true)
      }
    )
  } else if (message == "auth") {
    swalMessage("", "Authentication Failed", "error")
  } else if (message == "try") {
    swalMessage("", "Please Try Again", "error")
  } else if (message == "no update") {
    swalMessage("", "No Changes Found", "warning")
  } else {
    swalMessage("Error was not handled.", "System Error", "error", function () {
      swal.close()
      location.reload()
    })
  }
}

function addItem(added_item, div_container, remove_btn) {
  let itemCount = 2 // Initialize the item count to 1
  swalLoad("Generating")
  setTimeout(function () {
    swal.close()
    const originalItem = $("." + added_item)
      .first()
      .clone()
    // Clear the input values in the cloned div
    originalItem.find("input, textarea, select").val("")

    originalItem.find("input, textarea, select").each(function () {
      const oldName = $(this).attr("name")
      const oldId = $(this).attr("id")

      const newName = oldName.replace(/\d+$/, "") + itemCount
      const newId = oldId.replace(/\d+$/, "") + itemCount

      $(this).attr("name", newName)
      $(this).attr("id", newId)
    })

    originalItem.find("label").each(function () {
      const oldLabelFor = $(this).attr("for")
      if (oldLabelFor) {
        const newLabelFor = oldLabelFor.replace(/\d+$/, "") + itemCount
        $(this).attr("for", newLabelFor)
      }
    })

    // Append the cloned div to the container
    const container = $("." + div_container)
    container.append(originalItem)

    const spacer = $("<div>")
    spacer.css("height", "10px") // Adjust the height as needed for spacing

    // Append the spacer and the cloned div to the container
    container.append(spacer)
    container.append(originalItem)

    // Enable the "Remove last item" button
    $("#" + remove_btn).prop("disabled", false)

    itemCount++ // Increment the item count
  }, 500)

  $("#" + remove_btn).prop("disabled", false)
}

function removeItem(div_container, remove_btn) {
  swalLoad("Removing")
  setTimeout(function () {
    swal.close()
    // Get the container
    const container = document.querySelector("." + div_container)

    // Check if there are items to remove
    if (container.children.length > 1) {
      // Remove the last item and the spacer
      container.removeChild(container.lastChild)
      container.removeChild(container.lastChild)
    }

    // Disable the "Remove last item" button if there are no items left
    if (container.children.length === 1) {
      $("#" + remove_btn).prop("disabled", true)
    }
  }, 500)
}

// A J A X
// D A T A T A B L E
function initiateDTable(data, id, value) {
  var table = $(id).DataTable()
  table.clear().draw()
  $(id).dataTable().fnDestroy()
  var arr = []
  for (var i = 0; i < value.length; i++) {
    arr.push({ data: value[i] })
  }

  var table = $(id).DataTable({
    data: data,
    createdRow: function (row, data, dataIndex) {},
    columnDefs: [
      {
        targets: "_all",
        render: $.fn.dataTable.render.ellipsis(),
      },
    ],
    columns: arr,
  })
}

// function initiateDTableRender(data, id, value, renderF, _object = "") {
//   var table = $(id).DataTable()
//   table.clear().draw()
//   $(id).dataTable().fnDestroy()
//   var arr = []
//   for (var i = 0; i < value.length; i++) {
//     arr.push({ data: value[i], render: renderF[i] })
//   }

//   if (_object == "") {
//     var table = $(id).DataTable({
//       data: data,
//       columnDefs: [
//         {
//           targets: "_all",
//           render: $.fn.dataTable.render.ellipsis(),
//         },
//       ],
//       columns: arr,
//       createdRow: function (row, data, dataIndex) {
//         // alert("asd");
//       },
//     })
//   } else {
//     _object.data = data
//     _object.columns = arr
//     _object.columnDefs = [
//       {
//         targets: "_all",
//         render: $.fn.dataTable.render.ellipsis(),
//       },
//     ]
//     _object.createdRow = function (row, data, dataIndex) {
//       // alert("asd");
//     }
//     var table = $(id).DataTable(_object)
//   }
// }

function initiateDTableRender(data, id, value, renderF, _object = "") {
  var table = $(id).DataTable()
  table.clear().draw()
  $(id).dataTable().fnDestroy()
  var arr = []
  for (var i = 0; i < value.length; i++) {
    arr.push({ data: value[i], render: renderF[i] })
  }

  if (_object == "") {
    console.log("NADA")
    var table = $(id).DataTable({
      data: data,
      columnDefs: [
        {
          targets: "_all",
          render: $.fn.dataTable.render.ellipsis(),
        },
        {
          targets: -1,
          className: "text-center",
        },
      ],
      columns: arr,
      createdRow: function (row, data, dataIndex) {
        // alert("asd");
      },
    })
  } else {
    _object.data = data
    _object.columns = arr
    _object.columnDefs = [
      {
        targets: "_all",
        render: $.fn.dataTable.render.sis(),
      },
    ]
    _object.createdRow = function (row, data, dataIndex) {
      // alert("asd");
    }
    var table = $(id).DataTable(_object)
  }
}

function initiateDTablePDS(id, column_sort = 0, sort_type = "asc") {
  var table = $(id).DataTable()
  $(id).dataTable().fnDestroy()

  var table = $(id).DataTable({
    searching: false,
    paging: false,
    columnDefs: [
      {
        targets: "_all",
        render: $.fn.dataTable.render.ellipsis(),
      },
    ],
    info: false,
    order: [[column_sort, sort_type]],
  })

  return table
}
// D A T A T A B L E
// V A L I D A T E
$.validator.addMethod(
  "valid_mobile_number",
  function (value, element, param) {
    if (value.length > 2) {
      if (value[0] == 0 && value[1] == 9) {
        return true
      } else {
        return false
      }
    } else {
      return true
    }
  },
  "Invalid Format - Must start with 09"
)

$.validator.addMethod(
  "SG_with_SI",
  function (value, element, param) {
    if (value) {
      if (/^[0-9]{2}-[0-9]{1}$/.test(value)) {
        return true
      } else {
        return false
      }
    } else {
      return true
    }
  },
  'Invalid Format - Must be in "00-0" format (Salary Grade - Step)'
)

$.validator.addMethod(
  "SG_with_SI_range",
  function (value, element, param) {
    if (value) {
      var sg__ = value.split("-")[0]
      var si__ = value.split("-")[1]

      if (!(sg__ >= 1 && sg__ <= 33)) {
        return false
      }
      if (!(si__ >= 1 && si__ <= 8)) {
        return false
      }

      return true
    } else {
      return true
    }
  },
  "Out of range - The range for SG is 01-33 and the range for Step is 1-8"
)

$.validator.addMethod(
  "greaterThan",
  function (value, element, param) {
    if ($(param).val()) {
      if (value > $(param).val()) {
        return true
      } else {
        return false
      }
    } else {
      return true
    }
  },
  "Must be greater than previous"
)

$.validator.addMethod(
  "greaterThanOrEqualTo",
  function (value, element, param) {
    if ($(param).val()) {
      if (value >= $(param).val()) {
        return true
      } else {
        return false
      }
    } else {
      return true
    }
  },
  "Must be greater than or equal to previous"
)

$.validator.addMethod(
  "emailFormat",
  function (value, element) {
    return (
      this.optional(element) ||
      /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(
        value
      )
    )
  },
  "Please enter a valid email address."
)

$.validator.addMethod(
  "fileFormat",
  function (value, element, param) {
    var fileExtension = param
    if ($.inArray(value.split(".").pop().toLowerCase(), fileExtension) == -1) {
      return false
    } else {
      return true
    }
  },
  "Invalid file format (pdf, doc, docx, jpg, png, jpeg)"
)

$.fn.clearValidation = function () {
  var v = $(this).validate()
  $("[name]", this).each(function () {
    v.successList.push(this)
    v.showErrors()
  })
  v.resetForm()
  v.reset()
}
// V A L I D A T E
// D A T E P I C K E R
function initializeDatePicker(id, option = "") {
  if (option == "") {
    option = { format: "yyyy-mm-dd", startView: 2 }
  } else {
    if (option.format) {
    } else {
      option.format = "yyyy-mm-dd"
      option.startView = 2
    }
  }

  option.autoclose = true
  option.clearBtn = true

  $(document).on("focus", id, function () {
    $(id).datepicker(option)
  })

  $(id).prop("readonly", true)
  $(id).css("background-color", "white")
  $(id).css("cursor", "pointer")
}

function stringToArrayOfDates(_str, _char = ",") {
  var temp_str = _str.split(_char)
  var temp_arr = []
  for (var i = 0; i < temp_str.length; i++) {
    var yyyy = temp_str[i].split("-")[0]
    var mm = parseInt(temp_str[i].split("-")[1]) - 1
    var dd = temp_str[i].split("-")[2]
    temp_arr.push(new Date(yyyy, mm, dd))
  }

  return temp_arr.length == 0 ? "" : temp_arr
}
// D A T E P I C K E R
// A D D R E S S
function initializeAddress(_province, _municipality, _barangay) {
  var add_prov, add_mun, add_bar
  ;(add_prov = document.getElementById(_province)),
    (add_mun = document.getElementById(_municipality)),
    (add_bar = document.getElementById(_barangay))
  for (var i in stateObject)
    add_prov.options[add_prov.options.length] = new Option(i, i)
  ;(add_prov.onchange = function () {
    if (
      ((add_mun.length = 1), (add_bar.length = 1), !(this.selectedIndex < 1))
    ) {
      for (var add_prov in stateObject[this.value])
        add_mun.options[add_mun.options.length] = new Option(add_prov, add_prov)
      ;(add_mun.selectedIndex = 0), (add_bar.selectedIndex = 0)
    }
  }),
    add_prov.onchange(),
    (add_mun.onchange = function () {
      if (((add_bar.length = 1), !(this.selectedIndex < 1))) {
        for (
          var add_mun = stateObject[add_prov.value][this.value], i = 0;
          i < add_mun.length;
          i++
        )
          add_bar.options[add_bar.options.length] = new Option(
            add_mun[i],
            add_mun[i]
          )
        add_bar.selectedIndex = 0
      }
    })
}
// A D D R E S S
// C O U N T R Y
function initializeCountry(id, include = false) {
  var temp_Country = ""
  for (var i_country = 0; i_country < countries.length; i_country++) {
    if (countries[i_country].code == "PH") {
      if (include)
        temp_Country +=
          "<option value='" +
          countries[i_country].name +
          "'>" +
          countries[i_country].name +
          "</option>"
    } else {
      temp_Country +=
        "<option value='" +
        countries[i_country].name +
        "'>" +
        countries[i_country].name +
        "</option>"
    }
  }
  $(id).html(temp_Country)
}
// C O U N T R Y
// S E L E C T 2
function initializeSelect2Ledger(_id, _url, _valid = false) {
  $("#" + _id)
    .select2({
      minimumInputLength: 3,
      allowClear: true,
      placeholder: "--Select--",
      ajax: {
        type: "POST",
        url: "../../controllers/filter/" + _url,
        delay: 400,
        dataType: "json",
        data: function (params) {
          return {
            token: $("#token").val(),
            toFilter: params.term,
            select2: true,
          }
        },
        processResults: function (data, params) {
          if (data.mess == "connection") {
            swalMessage(
              "The Server is temporarily unable to serve your request due to maintenance, downtime or capacity problem. Please try again later.",
              "Service Unavailable",
              "warning",
              function () {
                swal.close()
              }
            )
          } else if (data.mess == "token") {
            swalMessage("", "Invalid Token", "warning", function () {
              swal.close()
              // loadPage();
            })
          } else if (data.mess == "timeout") {
            swalMessage(
              "Your account will be logged out as there was no request in 30 minutes.",
              "Session Timeout ",
              "warning",
              function () {
                swal.close()
                loadPage(
                  "../../controllers/shared/logout_ctrlr.php?timeout=true",
                  true
                )
              }
            )
          } else {
            var select2Data = $.map(data, function (obj) {
              return obj
            })

            return {
              results: select2Data,
            }
          }
        },
      },
    })
    .next()
    .after(
      '<label id="' +
        _id +
        '-error" class="error" for = "' +
        _id +
        '" style = "display: none"></label>'
    )

  $(".select2").css("width", "100%")

  if (_valid) {
    $("#" + _id).on("select2:select", function (e) {
      $("#" + _id).valid()
    })
  }
}

function goBack() {
  window.history.back()
}

function hideLinks() {
  $(".vm").prop("hidden", true)
  $(".lin").prop("hidden", true)
  $(".coun").prop("hidden", true)
  $(".ne").prop("hidden", true)
  $("search-item").prop("hidden", true)
}

function displayFileInNewTab(path) {
  var win = window.open(path, "_blank")
  if (win) {
    win.focus()
  } else {
    alert("Please allow popups for this website")
  }
}

// Added function

function toggleOffcanvas(id) {
  let offcanvasElement = document.getElementById(id)
  let offcanvas = bootstrap.Offcanvas.getInstance(offcanvasElement)

  if (offcanvas) {
    if (offcanvas._isShown) {
      offcanvas.hide()
      document.body.style.paddingRight = "0" // Reset body padding
    } else {
      offcanvas.show()
      document.body.style.paddingRight = "" // Remove custom padding (if any)
    }
  } else {
    offcanvas = new bootstrap.Offcanvas(offcanvasElement)
    offcanvas.show()
    document.body.style.paddingRight = "" // Remove custom padding (if any)
  }
}

function hideToggleOffcanvas(id) {
  let offcanvasElement = document.getElementById(id)
  let offcanvas = bootstrap.Offcanvas.getInstance(offcanvasElement)

  if (offcanvas) {
    if (offcanvas._isShown) {
      offcanvas.hide()
      document.body.style.paddingRight = "0" // Reset body padding
    } else {
      offcanvas.hide()
      document.body.style.paddingRight = "" // Remove custom padding (if any)
    }
  } else {
    offcanvas = new bootstrap.Offcanvas(offcanvasElement)
    offcanvas.hide()
    document.body.style.paddingRight = "" // Remove custom padding (if any)
  }
}

function showPassword() {
  $(".toggle-password").click(function () {
    const old_passwordInput = $("#oldPassword")
    const new_passwordInput = $("#newPassword")
    const confPasswordInput = $("#confirmPassword")
    const icon = $(this).find("i")

    if (
      old_passwordInput.attr("type") === "password" ||
      new_passwordInput.attr("type") === "password" ||
      confPasswordInput.attr("type") === "password"
    ) {
      old_passwordInput.attr("type", "text")
      new_passwordInput.attr("type", "text")
      confPasswordInput.attr("type", "text")
      icon.removeClass("fa-eye").addClass("fa-eye-slash")
    } else {
      old_passwordInput.attr("type", "password")
      new_passwordInput.attr("type", "password")
      confPasswordInput.attr("type", "password")
      icon.removeClass("fa-eye-slash").addClass("fa-eye")
    }
  })
}
